import { NetworkType } from 'symbol-sdk';
export interface CertificatePair {
    privateKey?: string;
    publicKey: string;
}
export interface ConfigAccount extends CertificatePair {
    address: string;
}
export interface NodeAccount {
    main: ConfigAccount;
    transport: ConfigAccount;
    remote?: ConfigAccount;
    vrf?: ConfigAccount;
    voting?: ConfigAccount;
    agent?: ConfigAccount;
    roles: string;
    name: string;
    friendlyName: string;
}
export interface MosaicAccounts {
    name: string;
    id: string;
    type: 'currency' | 'harvest';
    accounts: ConfigAccount[];
}
export interface Addresses {
    version: number;
    nodes?: NodeAccount[];
    nemesisGenerationHashSeed: string;
    sinkAddress: string;
    nemesisSigner?: ConfigAccount;
    networkType: NetworkType;
    mosaics?: MosaicAccounts[];
}
