import { NetworkType } from 'symbol-sdk';
import { CertificatePair } from '../model';
export interface AgentCertificateParams {
    readonly target: string;
    readonly user: string;
}
export interface AgentCertificates {
    agent: CertificatePair;
}
export interface AgentCertificateMetadata {
    readonly agentPublicKey: string;
    readonly version: number;
}
export declare class AgentCertificateService {
    private readonly root;
    protected readonly params: AgentCertificateParams;
    private static readonly METADATA_VERSION;
    constructor(root: string, params: AgentCertificateParams);
    run(networkType: NetworkType, symbolServerToolsImage: string, name: string, providedCertificates: AgentCertificates, customCertFolder?: string): Promise<void>;
    private shouldGenerateCertificate;
    private createCertCommands;
}
