import { flags } from '@oclif/command';
import { IOptionFlag } from '@oclif/command/lib/flags';
import { NetworkType } from 'symbol-sdk';
import { CertificatePair } from '../model';
import { KeyName } from './ConfigService';
export declare class CommandUtils {
    static passwordPromptDefaultMessage: string;
    static helpFlag: import("@oclif/parser/lib/flags").IBooleanFlag<void>;
    static targetFlag: flags.IOptionFlag<string>;
    static passwordFlag: flags.IOptionFlag<string | undefined>;
    static noPasswordFlag: import("@oclif/parser/lib/flags").IBooleanFlag<boolean>;
    static getPasswordFlag(description: string): IOptionFlag<string | undefined>;
    static isValidPassword(input: string | undefined): boolean | string;
    static isValidPrivateKey(input: string): boolean | string;
    static resolvePrivateKey(networkType: NetworkType, account: CertificatePair | undefined, keyName: KeyName, nodeName: string, operationDescription: string): Promise<string>;
    static resolvePassword(providedPassword: string | undefined, noPassword: boolean, message: string, log: boolean): Promise<string | undefined>;
}
