import { ConfigPreset, NodeAccount, NodePreset } from '../model';
import { ConfigParams } from './ConfigService';
declare type VotingParams = ConfigParams;
export interface VotingMetadata {
    readonly votingKeyStartEpoch: number;
    readonly votingKeyEndEpoch: number;
    readonly votingPublicKey: string;
    readonly version: number;
}
export declare class VotingService {
    protected readonly params: VotingParams;
    private static readonly METADATA_VERSION;
    constructor(params: VotingParams);
    run(presetData: ConfigPreset, nodeAccount: NodeAccount, nodePreset: NodePreset | undefined): Promise<void>;
    private shouldGenerateVoting;
}
export {};
